include "Vram.inc"
include "VVram.inc"
include "Chars.inc"

VramTop equ Vram

ext VVramFront_, RowFlags_
ext ColorChars_, MonoChars_

PatternRam equ 4000h
CharVram equ 0000h
AttrVram equ 0800h

dseg
Backup:
    defs VVramWidth*VVramHeight
; PatternRam: public PatternRam
;     defs PatternSize*Char_Man

cseg
PatternAddress:
    push de
        ld l,a
        ld h,0
        add hl,hl ;*2
        add hl,hl ;*4
        add hl,hl ;*8
        add hl,hl ;*16
        add hl,hl ;*32
        ld de,PatternRam
        add hl,de
    pop de
ret


; void MakePatternMono(byte c, ptr<byte> pSource, byte count, byte color);
dseg
    MakePatternMono_@Param3: public MakePatternMono_@Param3
    MakePatternMono_color:
    defb 0
cseg
MakePatternMono_: public MakePatternMono_
    push af | push hl | push de | push bc
        exx
            call PatternAddress

            ld a,(MakePatternMono_@Param3)
            ld e,a
            and 0fh
            ld d,a
            ld a,e
            srl a | srl a | srl a | srl a
            ld e,a
        exx
        do
            ld b,CharHeight
            do
                ld a,(de)
                ld l,a
                inc de
                ld h,8
                xor a
                do
                    sla l
                    if c
                        exx
                            or d
                        exx
                    else
                        exx
                            or e
                        exx
                    endif
                    bit 0,h
                    if nz
                        exx
                            ld (hl),a
                            inc hl
                            xor a
                        exx
                    else
                        rlca | rlca | rlca | rlca
                    endif
                    dec h
                while nz | wend
            dwnz
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


; void InitCG();
InitCG_: public InitCG_
    push af | push hl | push de | push bc
        ld hl,1000h+80h*CharHeight
        ld de,MonoChars_+18*CharHeight
        ld b,CharHeight*2
        do
            ld a,(de) | inc de
            push bc
                ld b,l
                ld c,h
                out (c) ,a
            pop bc
            inc hl
        dwnz
    pop bc | pop de | pop hl | pop af
ret


cseg
ClearRowFlags:
    xor a
    ld hl,RowFlags_
    ld b,4
    do
        ld (hl),a
        inc hl
    dwnz
ret


; void ClearScreen();
ClearScreen_: public ClearScreen_
    push af | push hl | push de | push bc
        ld hl,Vram
        ld de,8000h
        do
            ld b,l
            ld c,h
            xor a
            out (c),a
            inc hl
            dec de
            ld a,e
            or d
        while nz | wend

        ld hl,CharVram
        ld de,0800h
        do
            ld b,l
            ld c,h
            xor a
            out (c),a
            inc hl
            dec de
            ld a,e
            or d
        while nz | wend

        ld hl,AttrVram
        ld de,0800h
        do
            ld b,l
            ld c,h
            ld a,1
            out (c),a
            inc hl
            dec de
            ld a,e
            or d
        while nz | wend

        ld hl,Backup
        ld bc,VVramWidth*VVramHeight
        do
            ld (hl),0
            inc hl
            dec bc
            ld a,c
            or b
        while nz | wend

        call ClearRowFlags
    pop bc | pop de | pop hl | pop af
ret


; word Put(word vram, byte c);
cseg
Put_: public Put_
    push af | push hl | push de | push bc
        ex de,hl
            push de
                ld a,l
                sub Char_Man
                if c
                    ld de, PatternRam
                else
                    ld l,a
                    ld de, ColorChars_
                endif
                ld h,0
                add hl,hl ;*2
                add hl,hl ;*4
                add hl,hl ;*8
                add hl,hl ;*16
                add hl,hl ;*32
                add hl,de
            pop de
        ex de,hl
        ld c,CharHeight
        do
            ld b,VramCellSize
            do
                push bc
                    ld b,l
                    ld c,h
                    ld a,(de)
                    inc de
                    out (c),a
                pop bc
                inc hl
            dwnz
            push de
                ld de,1000H-VramCellSize
                add hl,de
            pop de
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
    inc hl | inc hl | inc hl | inc hl
ret


VVramToVramRow:
    ld b,VVramWidth
    do 
        push bc 
            ld a,(de)
            inc de
            cp (hl)
            if nz
                ld (hl),a
                exx
                    push de
                        ld e,a
                        call Put_
                    pop de
                exx
            else
                exx
                    inc hl | inc hl | inc hl | inc hl
                exx
            endif
            inc hl
        pop bc
    dwnz
    exx
        push bc
            ld bc,VramRowSize-VVramWidth*4
            add hl,bc
        pop bc
    exx
ret


; void VVramToVramAll();
VVramToVramAll_: public VVramToVramAll_
    push af | push hl | push de | push bc
        ld de,VVramFront_
        ld hl,Backup
        exx
            ld hl,Vram
        exx
        ld c, VVramHeight
        do
            call VVramToVramRow
            dec c
        while nz | wend
        call ClearRowFlags
    pop bc | pop de | pop hl | pop af
ret


; void VVramToVramChanged();
VVramToVramChanged_: public VVramToVramChanged_
    push af | push hl | push de | push bc
        ld de,VVramFront_
        ld hl,Backup
        exx
            ld hl,Vram
            ld de,RowFlags_
            ex de,hl
                ld c,1
                ld b,(hl)
                inc hl
            ex de,hl
        exx
        ld c, VVramHeight ; vertical count    
        do
            exx
                ld a,b
                and c
            exx
            if nz
                call VVramToVramRow            
            else
                push bc
                    ld bc,VVramWidth
                    add hl,bc
                    ex de,hl
                        add hl,bc
                    ex de,hl
                pop bc
                exx
                    push bc
                        ld bc,VramRowSize
                        add hl,bc
                    pop bc
                exx
            endif
            exx
                sla c
                if z
                    ex de,hl
                        ld c,1
                        ld b,(hl)
                        inc hl
                    ex de,hl
                endif
            exx
            dec c
        while nz | wend
        call ClearRowFlags
    pop bc | pop de | pop hl | pop af
ret
